// 2004-02-14

#include <stdio.h>
#include <windows.h>

// ===========================================================================

class cCriticalSection{
public:
	cCriticalSection(void)	{ ::InitializeCriticalSection(&CrtSec);	}
	~cCriticalSection()		{ ::DeleteCriticalSection(&CrtSec);		}
	void Enter(void)  		{ ::EnterCriticalSection(&CrtSec);		}
	void Leave(void)  		{ ::LeaveCriticalSection(&CrtSec);		}
	CRITICAL_SECTION CrtSec;
};

class cCriticalSectionHelper{
public:
	cCriticalSectionHelper(cCriticalSection* CrtSec_) : CrtSec(CrtSec_) { CrtSec->Enter(); }
	~cCriticalSectionHelper() { CrtSec->Leave(); }
	cCriticalSection* CrtSec;
};

#define CRITICALSECTION_HELPER(a)  cCriticalSectionHelper CrtSecHelper(&a);

// ===========================================================================

class cPluginMouseInfo{
public:
	HWND	RagWindow;				// ROEBhEnh
	bool	WindowActiveFlag;		// ROEBhEANeBu
	bool	ModifyMousePosFlag;		// }EX̍WXV
	int		RagMouseX;				// }EXXW
	int		RagMouseY;				// }EXYW
	bool	ModifyButtonFlag;		// {^̏ԂXV
	bool	LeftButton;				// {^
	bool	RightButton;			// E{^
	bool	MiddleButton;			// {^
};

class cPluginProcList{
public:
	void (WINAPI* OnPolling)(cPluginMouseInfo* State);
	void (WINAPI* OnEndRagnarok)(void);
};

void WINAPI OnPolling(cPluginMouseInfo* Info);
void WINAPI OnEndRagnarok(void);

bool EndRagnarokFlag = FALSE;
cCriticalSection CrtSec;
cPluginProcList ProcList = {OnPolling, OnEndRagnarok};
HINSTANCE hInstance;
int MouseActionState = 0;

bool (WINAPI* AddPlugin)(const char* Name, cPluginProcList* List);
void (WINAPI* DelPlugin)(const char* Name);

#define RO_MF_WINDOW "RO_MouseFreedom Window"
#define PLUGIN_NAME  "RO_MF SamplePlugin"

// ===========================================================================

#pragma argsused
void WINAPI OnPolling(cPluginMouseInfo* MouseInfo)
{
	if(MouseActionState > 0){
		MouseInfo->ModifyMousePosFlag = TRUE;
		MouseInfo->RagMouseX = MouseActionState;
		MouseInfo->RagMouseY = MouseActionState * 6 / 10;
		MouseActionState ++;
		if(MouseActionState >= 200)
			MouseActionState = 0;
	}

	char str[256];
	sprintf(str, "%d, %d", MouseInfo->RagMouseX, MouseInfo->RagMouseY);
	::SetWindowText(MouseInfo->RagWindow, str);
}

void WINAPI OnEndRagnarok(void)
{
	CRITICALSECTION_HELPER(CrtSec)
	EndRagnarokFlag = TRUE;
}

#pragma argsused
int __stdcall OnTimer(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime)
{
	HWND hWnd = ::FindWindow(RO_MF_WINDOW, RO_MF_WINDOW);
	HINSTANCE Module = NULL;
	if(hWnd){
		Module = (HINSTANCE)::SendMessage(hWnd, WM_APP, 0, 0);
		::KillTimer(NULL, idEvent);
	}
	if(Module){
		*((FARPROC*)&AddPlugin) = ::GetProcAddress(Module, "AddPlugin");
		*((FARPROC*)&DelPlugin) = ::GetProcAddress(Module, "DelPlugin");
	}
	if(AddPlugin)
		AddPlugin(PLUGIN_NAME, &ProcList);

	return 0;
}

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	hInstance = hinst;

	if(reason == DLL_PROCESS_ATTACH){
		char ProcessFileName[256];
		::GetModuleFileName(NULL, ProcessFileName, 256);
		const char* FileName = strrchr(ProcessFileName, '\\');
		FileName = (FileName ? FileName + 1 : ProcessFileName);
		if(stricmp(FileName, "RagExe.exe") == 0)
			::SetTimer(NULL, 0, 1000, (TIMERPROC)OnTimer);
	}

	if(reason == DLL_PROCESS_DETACH){
		CRITICALSECTION_HELPER(CrtSec)
		HWND hWnd = ::FindWindow(RO_MF_WINDOW, RO_MF_WINDOW);
		if(EndRagnarokFlag == FALSE && hWnd && DelPlugin)
			DelPlugin(PLUGIN_NAME);
	}

	return 1;
}

// ===========================================================================

HHOOK CbtHook = NULL;
HHOOK KeyboardHook = NULL;

LRESULT CALLBACK CbtProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	return CallNextHookEx(CbtHook, nCode, wParam, lParam);
}

LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	// sĂ͂Ȃł͔
	if(nCode < 0 || nCode != HC_ACTION)
		return CallNextHookEx(KeyboardHook, nCode, wParam, lParam);

	// L[ԃfR[h
	bool KeyDownFlag = !(lParam & 0x80000000);
	static bool CtrlFlag  = FALSE;
	static bool ShiftFlag = FALSE;
	if(wParam == VK_CONTROL)
		CtrlFlag = KeyDownFlag;
	if(wParam == VK_SHIFT)
		ShiftFlag = KeyDownFlag;

	// }EX
	if(CtrlFlag && ShiftFlag && KeyDownFlag && wParam == VK_F1)
		MouseActionState = 1;

	return CallNextHookEx(KeyboardHook, nCode, wParam, lParam);
}

extern "C" bool WINAPI StartHook(void)
{
	CbtHook      = ::SetWindowsHookEx(WH_CBT,      (HOOKPROC)CbtProc,      hInstance, 0);
	if(CbtHook == NULL)	return FALSE;
	KeyboardHook = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, hInstance, 0);
	if(KeyboardHook == NULL){
		::UnhookWindowsHookEx(CbtHook);
		return FALSE;
	}
	return TRUE;
}

extern "C" void WINAPI EndHook(void)
{
	if(KeyboardHook)	::UnhookWindowsHookEx(KeyboardHook);
	if(CbtHook)			::UnhookWindowsHookEx(CbtHook);
}

// ===========================================================================

