// 2004-02-14

#include <stdio.h>
#include <windows.h>

// ===========================================================================

LRESULT CALLBACK WndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg){
	case WM_DESTROY:
		::PostQuitMessage(0);
		return 0;
	}

	return ::DefWindowProc(hWnd, Msg, wParam, lParam);
}

void StandBy(HINSTANCE hInstance)
{
	const char* Name = "RO_MF SamplePlugin";

	// EBhE쐬
	WNDCLASSEX wndclass;
	::ZeroMemory(&wndclass, sizeof(WNDCLASSEX));
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.hInstance     = hInstance;
	wndclass.lpszClassName = Name;
	wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wndclass.hCursor       = ::LoadCursor(NULL, IDC_ARROW);
	::RegisterClassEx(&wndclass);

	HWND hWnd = ::CreateWindow(Name, Name,
			WS_OVERLAPPEDWINDOW, 100, 100, 300, 200,
			NULL, NULL, hInstance, NULL);

	::ShowWindow(hWnd, SW_SHOW);
	::UpdateWindow(hWnd);

	MSG Msg;
	while(::GetMessage(&Msg, NULL, 0, 0)){
		::TranslateMessage(&Msg);
		::DispatchMessage(&Msg);
	}
}

bool (WINAPI* StartHook)(void);
void (WINAPI* EndHook)(void);

#pragma argsused
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	HINSTANCE Dll = ::LoadLibrary("PluginDll.dll");
	if(Dll == NULL){
		MessageBox(NULL, "DLLǂݍݎs", "RO_MF SamplePlugin", MB_OK);
		return 0;
	}
	*((FARPROC*)&StartHook) = ::GetProcAddress(Dll, "StartHook");
	*((FARPROC*)&EndHook)   = ::GetProcAddress(Dll, "EndHook");
	if(StartHook == NULL || EndHook == NULL){
		::FreeLibrary(Dll);
		MessageBox(NULL, "DLLǂݍݎs", "RO_MF SamplePlugin", MB_OK);
		return 0;
	}

	if(StartHook() == FALSE){
		MessageBox(NULL, "tbNs", "RO_MF SamplePlugin", MB_OK);
		return 0;
	}

	StandBy(hInstance);

	EndHook();

	::FreeLibrary(Dll);

	return 0;
}

// ===========================================================================

