// 2004-02-17

#include <stdio.h>
#include <windows.h>

// ===========================================================================

class cPluginMouseInfo{
public:
	HWND	RagWindow;				// ROEBhEnh
	bool	WindowActiveFlag;		// ROEBhEANeBu
	bool	ModifyMousePosFlag;		// }EX̍WXV
	int		RagMouseX;				// }EXXW
	int		RagMouseY;				// }EXYW
	bool	ModifyButtonFlag;		// {^̏ԂXV
	bool	LeftButton;				// {^
	bool	RightButton;			// E{^
	bool	MiddleButton;			// {^
};

HINSTANCE hInstance;
int MouseActionState = 0;

// ===========================================================================

HHOOK CbtHook = NULL;
HHOOK KeyboardHook = NULL;

LRESULT CALLBACK CbtProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	return CallNextHookEx(CbtHook, nCode, wParam, lParam);
}

LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	// sĂ͂Ȃł͔
	if(nCode < 0 || nCode != HC_ACTION)
		return CallNextHookEx(KeyboardHook, nCode, wParam, lParam);

	// L[ԃfR[h
	bool KeyDownFlag = !(lParam & 0x80000000);
	static bool CtrlFlag  = FALSE;
	static bool ShiftFlag = FALSE;
	if(wParam == VK_CONTROL)
		CtrlFlag = KeyDownFlag;
	if(wParam == VK_SHIFT)
		ShiftFlag = KeyDownFlag;

	// }EX
	if(CtrlFlag && ShiftFlag && KeyDownFlag && wParam == VK_F1)
		MouseActionState = 1;

	return CallNextHookEx(KeyboardHook, nCode, wParam, lParam);
}

bool WINAPI StartHook(void)
{
	CbtHook      = ::SetWindowsHookEx(WH_CBT,      (HOOKPROC)CbtProc,      hInstance, 0);
	if(CbtHook == NULL)	return FALSE;
	KeyboardHook = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, hInstance, 0);
	if(KeyboardHook == NULL){
		::UnhookWindowsHookEx(CbtHook);
		return FALSE;
	}
	return TRUE;
}

void WINAPI EndHook(void)
{
	if(KeyboardHook)	::UnhookWindowsHookEx(KeyboardHook);
	if(CbtHook)			::UnhookWindowsHookEx(CbtHook);
}

// ===========================================================================

extern "C" void WINAPI ROMF_OnPolling(cPluginMouseInfo* MouseInfo)
{
	if(MouseActionState > 0){
		MouseInfo->ModifyMousePosFlag = TRUE;
		MouseInfo->RagMouseX = MouseActionState;
		MouseInfo->RagMouseY = MouseActionState * 6 / 10;
		MouseActionState ++;
		if(MouseActionState >= 200)
			MouseActionState = 0;
	}

	char str[256];
	sprintf(str, "%d, %d", MouseInfo->RagMouseX, MouseInfo->RagMouseY);
	::SetWindowText(MouseInfo->RagWindow, str);
}

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	hInstance = hinst;

	if(reason == DLL_PROCESS_ATTACH)	StartHook();
	if(reason == DLL_PROCESS_DETACH)	EndHook();

	return 1;
}

// ===========================================================================

